/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */

final _upperCase = RegExp("[A-Z]");

extension StringX on String {
  String get kebabCase => _fixCase("-");

  String get snakeCase => _fixCase("_");

  String get screamingSnake => snakeCase.toUpperCase();

  String get pascalCase {
    if (isEmpty) return "";

    return this[0].toUpperCase() + substring(1);
  }

  String _fixCase(String separator) => replaceAllMapped(_upperCase, (match) {
        var lower = match.group(0)!.toLowerCase();

        if (match.start > 0) {
          lower = "$separator$lower";
        }

        return lower;
      });
}
